
<object id="plugin" type="application/x-nacl-imc">Plugin not working</object>

<script type="text/javascript" src="filelist.js"></script>

<script type="text/javascript">
var prefix_dir = "../install-stubout";
var args = ["--library-path", "/lib", "/usr/local/bin/python", "demo.py"];
var plugin;
var proc;
var input_field;
var output;

var S_IFDIR = 0x4000;

function receive(message) {
    var header = message.substring(0, 4);
    if(header == "Open") {
        open(normalize_path(message.substring(4)));
    }
    else if(header == "Stat") {
        stat(normalize_path(message.substring(4)));
    }
    else if(header == "Prnt") {
        print(message.substring(4), "normalOutput");
        refocus();
    }
    else {
        dump("unrecognised message: " + message + "\n");
        proc.send("Reply to unrecognised message", []);
    }
}

function normalize_path(pathname) {
    while(pathname[pathname.length-1] == "/") {
        pathname = pathname.substring(0, pathname.length-1);
    }
    // Python tries to open "./nacl.so" as well as "nacl.so"
    while(pathname.substring(0, 2) == "./") {
        pathname = pathname.substring(2)
    }
    return pathname;
}

/* imcplugin currently does not respond if we ask for a file that doesn't
   exist.  As a temporary workaround, we whitelist allowed files. */

function open(filename) {
    dump("open: " + filename + "\n");
    if(!files.hasOwnProperty(filename)) {
        proc.send("", []);
    }
    else {
        plugin.get_file(files[filename], function(file) {
            proc.send("", [file]);
        });
    }
}

function stat(filename) {
    dump("stat: " + filename + "\n");
    if(dirs.hasOwnProperty(filename)) {
        var fields = [0,0,S_IFDIR,0,0,0,0,0,0,0,0,0,0,0,0,0];
        proc.send("Rsta" + encode_stat(fields), []);
    }
    else if(files.hasOwnProperty(filename)) {
        var fields = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];
        proc.send("Rsta" + encode_stat(fields), []);
    }
    else {
        proc.send("Fail", []);
    }
}

function encode_stat(fields) {
    out = "";
    for(var i = 0; i < fields.length; i++) {
        var val = fields[i];
        out += String.fromCharCode(val & 0xff);
        out += String.fromCharCode((val >> 8) & 0xff);
        out += String.fromCharCode((val >> 16) & 0xff);
        out += String.fromCharCode((val >> 24) & 0xff);
    }
    return out;
}

function onload() {
    try {
        plugin = document.getElementById("plugin");
        plugin.get_file(prefix_dir + "/lib/ld-linux.so.2", function(file) {
            proc = plugin.launch(file, args, receive);
        });
    }
    catch(e) {
        dump(e + "\n");
    }

    input_field = document.getElementById("input");
    output = document.getElementById("output");
    refocus();
}
window.onload = onload;

/* This REPL is based loosely on the Javascript shell at
   http://www.squarefree.com/shell/
   The JavaScript shell was created by Jesse Ruderman.
   The JavaScript Shell is GPL/LGPL/MPL tri-licensed. */

function input_keydown(event) {
    if(event.keyCode == 13 && !event.shiftKey) {
        var data = input_field.value;
        if(data != "") {
            proc.send("Eval" + data, []);
            print(data, "input");
        }
        setTimeout(function() { input_field.value = ""; }, 0);
    }
    refocus();
}

function refocus() {
    input_field.blur();
    input_field.focus();
}

function print(text, style) {
    var newdiv = document.createElement("div");
    newdiv.appendChild(document.createTextNode(text));
    newdiv.className = style;
    output.appendChild(newdiv);
}
</script>

<style type="text/css">
body { background: white; color: black; }

#output { white-space: pre; white-space: -moz-pre-wrap; } /* Preserve line breaks, but wrap too if browser supports it */
h3 { margin-top: 0; margin-bottom: 0em; }
h3 + div { margin: 0; }

form { margin: 0; padding: 0; }
#input { width: 100%; border: none; padding: 0; overflow: auto; }

.input { color: blue; background: white; font: inherit; font-weight: bold; margin-top: .5em; }
.normalOutput { color: black; background: white; }
</style>

<div id="output"></div>
<div><textarea id="input" class="input" wrap="off" onkeydown="input_keydown(event)" rows="1"></textarea></div>
